Index: t3lib/class.t3lib_browsetree.php
===================================================================
--- t3lib/class.t3lib_browsetree.php	(revision 5403)
+++ t3lib/class.t3lib_browsetree.php	(working copy)
@@ -168,10 +168,25 @@
 		}
 		return $title;
 	}
+
+ 	/**
+	 * Adds a red "+" to the input string, $str, if the field "php_tree_stop" in the $row (pages) is set
+	 *
+	 * @param	string		Input string, like a page title for the tree
+	 * @param	array		record row with "php_tree_stop" field
+	 * @return	string		Modified string
+	 * @access private
+	 */
+	function wrapStop($str,$row)	{
+		if ($row['php_tree_stop'])	{
+			$str.='<span class="typo3-red"><a href="'.htmlspecialchars(t3lib_div::linkThisScript(array('setTempDBmount' => $row['uid']))).'" class="typo3-red">+</a> </span>';
+		}
+		return $str;
+	}		
 }
 
 if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_browsetree.php'])	{
 	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_browsetree.php']);
 }
 
-?>
\ No newline at end of file
+?>
Index: t3lib/class.t3lib_treeview.php
===================================================================
--- t3lib/class.t3lib_treeview.php	(revision 5403)
+++ t3lib/class.t3lib_treeview.php	(working copy)
@@ -550,7 +550,7 @@
 	 */
 	function wrapStop($str,$row)	{
 		if ($row['php_tree_stop'])	{
-			$str.='<span class="typo3-red">+ </span>';
+			$str.='<span class="typo3-red"><a href="'.htmlspecialchars(t3lib_div::linkThisScript(array('setTempDBmount' => $row['uid']))).'" class="typo3-red">+</a> </span>';
 		}
 		return $str;
 	}
@@ -1096,4 +1096,4 @@
 	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['t3lib/class.t3lib_treeview.php']);
 }
 
-?>
\ No newline at end of file
+?>
Index: typo3/browse_links.php
===================================================================
--- typo3/browse_links.php	(revision 5403)
+++ typo3/browse_links.php	(working copy)
@@ -133,6 +133,23 @@
 	 */
 	function main()	{
 
+		// Clear temporary DB mounts
+		$tmpMount = t3lib_div::_GET('setTempDBmount');
+		if (isset($tmpMount)) {
+			$GLOBALS['BE_USER']->setAndSaveSessionData('pageTree_temporaryMountPoint',intval($tmpMount));
+		}
+
+		// Set temporary DB mounts
+		$tempDBmount = intval($GLOBALS['BE_USER']->getSessionData('pageTree_temporaryMountPoint'));
+		if ($tempDBmount) {
+	 		$altMountPoints = $tempDBmount;
+		}
+		
+ 		if ($altMountPoints) {
+ 			$GLOBALS['BE_USER']->groupData['webmounts'] = implode(',', array_unique(t3lib_div::intExplode(',', $altMountPoints)));
+ 			$GLOBALS['WEBMOUNTS'] = $GLOBALS['BE_USER']->returnWebmounts();
+ 		}
+
 		$this->content = '';
 
 			// look for alternativ mountpoints
@@ -233,4 +250,4 @@
 $SOBE->main();
 $SOBE->printContent();
 
-?>
\ No newline at end of file
+?>
Index: typo3/class.browse_links.php
===================================================================
--- typo3/class.browse_links.php	(revision 5403)
+++ typo3/class.browse_links.php	(working copy)
@@ -1427,6 +1427,18 @@
 				$pagetree->thisScript = $this->thisScript;
 				$tree=$pagetree->getBrowsableTree();
 				$cElements = $this->expandPage();
+
+				// Outputting Temporary DB mount notice:
+				if (intval($GLOBALS['BE_USER']->getSessionData('pageTree_temporaryMountPoint')))	{
+					$dbmount= '
+			<div class="bgColor4 c-notice">
+				<img'.t3lib_iconWorks::skinImg('','gfx/icon_note.gif','width="18" height="16"').' align="top" alt="" />'.
+				'<a href="'.htmlspecialchars(t3lib_div::linkThisScript(array('setTempDBmount' => 0))).'">'.
+				$LANG->sl('LLL:EXT:lang/locallang_core.xml:labels.temporaryDBmount',1).
+				'</a>	</div>
+					';
+				}
+
 				$content.= '
 
 			<!--
@@ -1434,7 +1446,7 @@
 			-->
 					<table border="0" cellpadding="0" cellspacing="0" id="typo3-linkPages">
 						<tr>
-							<td class="c-wCell" valign="top">'.$this->barheader($GLOBALS['LANG']->getLL('pageTree').':').$tree.'</td>
+							<td class="c-wCell" valign="top">'.$this->barheader($GLOBALS['LANG']->getLL('pageTree').':').$dbmount.$tree.'</td>
 							<td class="c-wCell" valign="top">'.$cElements.'</td>
 						</tr>
 					</table>
@@ -2781,4 +2793,4 @@
 	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['typo3/class.browse_links.php']);
 }
 
-?>
\ No newline at end of file
+?>