Index: typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php
===================================================================
--- typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php	(révision 5052)
+++ typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php	(copie de travail)
@@ -317,13 +317,22 @@
 			$RTEHeight = isset($BE_USER->userTS['options.']['RTESmallHeight']) ? $BE_USER->userTS['options.']['RTESmallHeight'] : '380';
 			$RTEWidth  = $RTEWidth + ($this->TCEform->docLarge ? (isset($BE_USER->userTS['options.']['RTELargeWidthIncrement']) ? $BE_USER->userTS['options.']['RTELargeWidthIncrement'] : '150') : 0);
 			$RTEWidth -= ($inline->getStructureDepth() > 0 ? ($inline->getStructureDepth()+1)*$inline->getLevelMargin() : 0);
+			if (isset($this->thisConfig['RTEWidthOverride'])) {
+				if (strstr($this->thisConfig['RTEWidthOverride'], '%')) {
+					if ($this->client['BROWSER'] != 'msie') {
+						$RTEWidth = (intval($this->thisConfig['RTEWidthOverride']) > 0) ? $this->thisConfig['RTEWidthOverride'] : '100%';
+					}
+				} else {
+					$RTEWidth = (intval($this->thisConfig['RTEWidthOverride']) > 0) ? intval($this->thisConfig['RTEWidthOverride']) : $RTEWidth;
+				}
+			}
+			$RTEWidth = strstr($RTEWidth, '%') ? $RTEWidth :  $RTEWidth . 'px';
 			$RTEHeight = $RTEHeight + ($this->TCEform->docLarge ?  (isset($BE_USER->userTS['options.']['RTELargeHeightIncrement']) ? $BE_USER->userTS['options.']['RTELargeHeightIncrement'] : 0) : 0);
 			$RTEHeightOverride = intval($this->thisConfig['RTEHeightOverride']);
 			$RTEHeight = ($RTEHeightOverride > 0) ? $RTEHeightOverride : $RTEHeight;
-			$editorWrapWidth = $RTEWidth . 'px';
-			$editorWrapHeight = $RTEHeight . 'px';
-			$this->RTEdivStyle = 'position:relative; left:0px; top:0px; height:' . $RTEHeight . 'px; width:'.$RTEWidth.'px; border: 1px solid black; padding: 2px 0px 2px 2px;';
-			$this->toolbar_level_size = $RTEWidth;
+			$editorWrapWidth = '99%';
+			$editorWrapHeight = '100%';
+			$this->RTEdivStyle = 'position:relative; left:0px; top:0px; height:' . $RTEHeight . 'px; width:'.$RTEWidth.'; border: 1px solid black; padding: 2px 2px 2px 2px;';
 
 			/* =======================================
 			 * LOAD CSS AND JAVASCRIPT
Index: typo3/sysext/rtehtmlarea/doc/manual.sxw
===================================================================
Impossible d'afficher : fichier considéré comme binaire.
svn:mime-type = application/octet-stream
Index: typo3/sysext/rtehtmlarea/pi2/class.tx_rtehtmlarea_pi2.php
===================================================================
--- typo3/sysext/rtehtmlarea/pi2/class.tx_rtehtmlarea_pi2.php	(révision 5052)
+++ typo3/sysext/rtehtmlarea/pi2/class.tx_rtehtmlarea_pi2.php	(copie de travail)
@@ -195,15 +195,25 @@
 		 * =======================================
 		 */
 
-		$RTEWidth = 460+($this->TCEform->docLarge ? 150 : 0);
-		$RTEHeight = 380;
+		$width = 460+($this->TCEform->docLarge ? 150 : 0);
+		if (isset($this->thisConfig['RTEWidthOverride'])) {
+			if (strstr($this->thisConfig['RTEWidthOverride'], '%')) {
+				if ($this->client['BROWSER'] != 'msie') {
+					$width = (intval($this->thisConfig['RTEWidthOverride']) > 0) ? $this->thisConfig['RTEWidthOverride'] : '100%';
+				}
+			} else {
+				$width = (intval($this->thisConfig['RTEWidthOverride']) > 0) ? intval($this->thisConfig['RTEWidthOverride']) : $width;
+			}
+		}
+		$RTEWidth = strstr($width, '%') ? $width : $width . 'px';
+		$editorWrapWidth = strstr($width, '%') ? $width :  ($width+2) . 'px';
+		$height = 380;
 		$RTEHeightOverride = intval($this->thisConfig['RTEHeightOverride']);
-		$RTEHeight = ($RTEHeightOverride > 0) ? $RTEHeightOverride : $RTEHeight;
-		$editorWrapWidth = $RTEWidth . 'px';
-		$editorWrapHeight = $RTEHeight . 'px';
-		$this->RTEWrapStyle = $this->RTEWrapStyle ? $this->RTEWrapStyle : ($this->RTEdivStyle ? $this->RTEdivStyle : ('height:' . ($RTEHeight+2) . 'px; width:'. ($RTEWidth+2) . 'px;'));
-		$this->RTEdivStyle = $this->RTEdivStyle ? $this->RTEdivStyle : 'position:relative; left:0px; top:0px; height:' . $RTEHeight . 'px; width:'.$RTEWidth.'px; border: 1px solid black;';
-		$this->toolbar_level_size = $RTEWidth;
+		$height = ($RTEHeightOverride > 0) ? $RTEHeightOverride : $height;
+		$RTEHeight = $height . 'px';
+		$editorWrapHeight = ($height+2) . 'px';
+		$this->RTEWrapStyle = $this->RTEWrapStyle ? $this->RTEWrapStyle : ($this->RTEdivStyle ? $this->RTEdivStyle : ('height:' . $editorWrapHeight . '; width:'. $editorWrapWidth . ';'));
+		$this->RTEdivStyle = $this->RTEdivStyle ? $this->RTEdivStyle : 'position:relative; left:0px; top:0px; height:' . $RTEHeight . '; width:'.$RTEWidth.'; border: 1px solid black;';
 
 		/* =======================================
 		 * LOAD JS, CSS and more